<template>
  <div>
    <table class="table  table-striped" v-if="transferenciaStore.listadoTransferencias.length > 0">
      <thead>
        <tr>
          <th scope="col">Fecha</th>
          <th scope="col">Tipo Transferencia</th>
          <th scope="col">Total Ajuste</th>
          <th scope="col">Observaciones</th>
          <th scope="col">Acciones</th>
        </tr>
      </thead>
      <tbody>
        <tr v-for="transf in transferenciaStore.listadoTransferencias" :key="transf.id_cupo_movimiento_cabecera">
          <td v-text="formatDate(transf.f_transf)"></td>
          <td v-text="transf.d_tipo_transf"></td>
          <td style="background-color: lightgray;text-align: right;" v-text="'$' + formatPrice(transf.tot_ajuste)"></td>
          <td v-text="transf.observ"></td>
          <td>
            <button class="btn btn-principal btn-sm pt-0 pb-0 px-1 mb-2 mt-0" alt="Ver Detalle" title="Detalle"
              @click="mostrarDetalle(transf)">
              <i class="bi bi-search text-light fs-6"></i>
            </button>
            <!-- BORRAR -->
            <button  class="btn btn-borrar  mx-2 text-uppercase p-0 px-2 fs-5" alt="Borrar" title="Borrar"
              @click="borrar(transf)">
              <i class="fa-solid fa-trash-can"></i>
            </button>

          </td>
        </tr>
      </tbody>
    </table>
    <div v-else class="alert alert-secondary" role="alert">
      No hay elementos para mostrar
    </div>

    <Modal ref="modalCabecera" :title="''" size="xl" :vertical-centered="true">
      <DetalleCabecera :transferenciaCabecera="data.transferenciaCabecera!" />
    </Modal>
  </div>
</template>
  
<script setup lang="ts">

//librerias
import { ref, reactive } from "vue";
import { Modal } from "@hcd-bsas/vue3-components";
import { loading, urlApi } from "@/shared.js";
import http from "@/http";
import Swal from "sweetalert2/dist/sweetalert2.js";
import type { SweetAlertOptions } from "sweetalert2";
import type { AxiosError } from "axios";
import { DateTime } from "luxon";
//store
//import { useTopesStore } from "@/stores/Topes/topes";
import { useTransferenciasStore } from "@/stores/transferencias/transferencias";
import { useConfigStore } from "@/stores/configgral";
//component
import DetalleCabecera from "@/components/Cupos/AjusteBajaSolicitante/DetalleCabecera.vue";
//import type Cupo from "@/entities/becas/Cupo";
import Cupos from "@/entities/Cupos/Cupo";

const transferenciaStore = useTransferenciasStore();
const configStore = useConfigStore()
const modalCabecera = ref<typeof Modal>();

function formatDate(date: string | null) {
  if (date != null) {
    return DateTime.fromISO(date).toLocaleString();
  }
}

function formatPrice(value: any) {
  let val = (value / 1).toFixed(2).replace('.', ',')
  return val.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ".")
}

var data = reactive({
  transferenciaCabecera: null as Cupos | null,

});

function mostrarDetalle(transf: Cupos) {
  data.transferenciaCabecera = transf;
  modalCabecera.value!.show();
}


function borrar(transf: Cupos) {
/*   console.log(transf);
  console.log(transf.id_cupo_movimiento_cabecera);
  console.log(transf.id_tabla_sol);
  console.log(transf.tipo_transf);
  console.log(transf.id_transferencia); */
  
  const swal_error: SweetAlertOptions<any, any> = {
    icon: "error",
    title: "Error",
    html: "",
  }

  Swal.fire({
    icon: "question",
    title: "Confirmaci&oacute;n",
    html: "¿Confirma la eliminaci&oacute;n del Cupo? Esta acci&oacute;n no podr&aacute; ser revertida.",
    showCancelButton: true,
    confirmButtonColor: "#3085d6",
    cancelButtonColor: "#d33",
    confirmButtonText: "Confirmar",
    cancelButtonText: "Cancelar",
  }).then(async (result) => {
    if (result.isConfirmed) {
      loading.show();
      await http.post(urlApi + "deleteCupoSolicitanteGrabar", {
        tipo_transf: transf.tipo_transf,
        accion: "B",
        id_cupo_movimiento_cabecera: transf.id_cupo_movimiento_cabecera,
        id_transferencia: transf.id_transferencia,
        id_tabla_sol: transf.id_tabla_sol,
        id_tabla_sol_reemp: transf.id_tabla_sol_reemp
      }).then(async () => {
        var anio = configStore.listadoPeriodoActivo[0]?.anioActivo;
        var fecha_desde = anio + "-03-01";
        var fecha_hasta = anio + "-12-31";
        await transferenciaStore.updateListadoTransferenciasCabeceras({
          id_cargo: null,
          id_tabla_sol: transf.id_tabla_sol,
          tipo_transf: "J",
          f_transf_desde: fecha_desde,
          f_transf_hasta: fecha_hasta,
        });
        Swal.fire({
          icon: "success",
          text: "Se Borro La Transferencia.",
        })
        loading.hide();
      }).catch(function (error: AxiosError<string, any>) {
        if (error.response) {
          // Request made and server responded
          swal_error.html =
            error.message +
            " (" +
            error.code +
            ")." +
            "<br />" +
            error.response.data.substring(
              error.response.data.indexOf("<h2>") + 4,
              error.response.data.indexOf("</h2>")
            );
          console.log("Error: request made and server responded");
          console.log(swal_error.html);
          console.log(error.response);
        } else if (error.request) {
          // The request was made but no response was received
          swal_error.html =
            "Error desconocido. Por favor, avise al Administrador.";
          console.log("Error: the request was made but no response was received");
          console.log(error.request);
        } else {
          // Something happened in setting up the request that triggered an Error
          swal_error.html =
            "Error desconocido. Por favor, avise al Administrador.";
          console.log(
            "Error: something happened in setting up the request that triggered an error"
          );
          console.log(error);
        }
        loading.hide();
        Swal.fire(swal_error);
      });
    }
  });
}

</script>

<style>

#subbecas {
    background-color: lightpink;
}

#becas_sub{
    background-color: lightgray;
}
</style>
  